5 # Never run this makefile in parallel, as it could screw things up
6 # It won't affect the submakes, so you still get the speedup from specifying -jx
9 # Allow the silent with lower caps to work the same way as upper caps
15 SUB_IS_SILENT := $(SILENT)
18 # We need to make sure that silent is always turned off at the top level
19 # Otherwise the [OK], [ERROR] and [WARN] messages won't be displayed correctly
20 override SILENT := false
23 QMK_VERSION := $(shell git describe --abbrev=0 --tags 2>/dev/null)
24 ifneq ($(QMK_VERSION),)
25 $(info QMK Firmware $(QMK_VERSION))
29 ON_ERROR := error_occurred=1
33 STARTING_MAKEFILE := $(firstword $(MAKEFILE_LIST))
34 ROOT_MAKEFILE := $(lastword $(MAKEFILE_LIST))
35 ROOT_DIR := $(dir $(ROOT_MAKEFILE))
39 ABS_STARTING_MAKEFILE := $(abspath $(STARTING_MAKEFILE))
40 ABS_ROOT_MAKEFILE := $(abspath $(ROOT_MAKEFILE))
41 ABS_STARTING_DIR := $(dir $(ABS_STARTING_MAKEFILE))
42 ABS_ROOT_DIR := $(dir $(ABS_ROOT_MAKEFILE))
43 STARTING_DIR := $(subst $(ABS_ROOT_DIR),,$(ABS_STARTING_DIR))
44 BUILD_DIR := $(ROOT_DIR)/.build
45 TEST_DIR := $(BUILD_DIR)/test
46 ERROR_FILE := $(BUILD_DIR)/error_occurred
50 # Helper function to process the newt element of a space separated path
51 # It works a bit like the traditional functional head tail
52 # so the CURRENT_PATH_ELEMENT will become the new head
53 # and the PATH_ELEMENTS are the rest that are still unprocessed
54 define NEXT_PATH_ELEMENT
55 $$(eval CURRENT_PATH_ELEMENT := $$(firstword $$(PATH_ELEMENTS)))
56 $$(eval PATH_ELEMENTS := $$(wordlist 2,9999,$$(PATH_ELEMENTS)))
59 # We change the / to spaces so that we more easily can work with the elements
61 PATH_ELEMENTS := $(subst /, ,$(STARTING_DIR))
62 # Initialize the path elements list for further processing
63 $(eval $(call NEXT_PATH_ELEMENT))
65 # This function sets the KEYBOARD; KEYMAP and SUBPROJECT to the correct
66 # variables depending on which directory you stand in.
67 # It's really a very simple if else chain, if you squint enough,
68 # but the makefile syntax makes it very verbose.
69 # If we are in a subfolder of keyboards
71 # *** No longer needed **
73 # ifeq ($(CURRENT_PATH_ELEMENT),keyboards)
74 # $(eval $(call NEXT_PATH_ELEMENT))
75 # KEYBOARD := $(CURRENT_PATH_ELEMENT)
76 # $(eval $(call NEXT_PATH_ELEMENT))
77 # # If we are in a subfolder of keymaps, or in other words in a keymap
79 # ifeq ($(CURRENT_PATH_ELEMENT),keymaps)
80 # $(eval $(call NEXT_PATH_ELEMENT))
81 # KEYMAP := $(CURRENT_PATH_ELEMENT)
82 # # else if we are not in the keyboard folder itself
83 # else ifneq ($(CURRENT_PATH_ELEMENT),)
84 # # the we can assume it's a subproject, as no other folders
85 # # should have make files in them
86 # SUBPROJECT := $(CURRENT_PATH_ELEMENT)
87 # $(eval $(call NEXT_PATH_ELEMENT))
88 # # if we are inside a keymap folder of a subproject
89 # ifeq ($(CURRENT_PATH_ELEMENT),keymaps)
90 # $(eval $(call NEXT_PATH_ELEMENT))
91 # KEYMAP := $(CURRENT_PATH_ELEMENT)
97 All_RULES_MK := $$(patsubst $(ROOT_DIR)/keyboards/%/rules.mk,%,$$(wildcard $(ROOT_DIR)/keyboards/*/rules.mk))
98 All_RULES_MK += $$(patsubst $(ROOT_DIR)/keyboards/%/rules.mk,%,$$(wildcard $(ROOT_DIR)/keyboards/*/*/rules.mk))
99 All_RULES_MK += $$(patsubst $(ROOT_DIR)/keyboards/%/rules.mk,%,$$(wildcard $(ROOT_DIR)/keyboards/*/*/*/rules.mk))
100 All_RULES_MK += $$(patsubst $(ROOT_DIR)/keyboards/%/rules.mk,%,$$(wildcard $(ROOT_DIR)/keyboards/*/*/*/*/rules.mk))
102 KEYMAPS_MK := $$(patsubst $(ROOT_DIR)/keyboards/%/rules.mk,%,$$(wildcard $(ROOT_DIR)/keyboards/*/keymaps/*/rules.mk))
103 KEYMAPS_MK += $$(patsubst $(ROOT_DIR)/keyboards/%/rules.mk,%,$$(wildcard $(ROOT_DIR)/keyboards/*/*/keymaps/*/rules.mk))
104 KEYMAPS_MK += $$(patsubst $(ROOT_DIR)/keyboards/%/rules.mk,%,$$(wildcard $(ROOT_DIR)/keyboards/*/*/*/keymaps/*/rules.mk))
105 KEYMAPS_MK += $$(patsubst $(ROOT_DIR)/keyboards/%/rules.mk,%,$$(wildcard $(ROOT_DIR)/keyboards/*/*/*/*/keymaps/*/rules.mk))
107 KEYBOARDS := $$(sort $$(filter-out $$(KEYMAPS_MK), $$(All_RULES_MK)))
110 $(eval $(call GET_KEYBOARDS))
112 # Only consider folders with makefiles, to prevent errors in case there are extra folders
113 #KEYBOARDS += $(patsubst $(ROOD_DIR)/keyboards/%/rules.mk,%,$(wildcard $(ROOT_DIR)/keyboards/*/*/rules.mk))
115 .PHONY: list-keyboards
119 define PRINT_KEYBOARD
120 $(info $(PRINTING_KEYBOARD))
123 .PHONY: generate-keyboards-file
124 generate-keyboards-file:
125 $(foreach PRINTING_KEYBOARD,$(KEYBOARDS),$(eval $(call PRINT_KEYBOARD)))
129 echo -n 'Deleting .build/ ... '
135 echo -n 'Deleting *.bin and *.hex ... '
139 #Compatibility with the old make variables, anything you specify directly on the command line
140 # always overrides the detected folders
142 KEYBOARD := $(keyboard)
148 # Uncomment these for debugging
149 # $(info Keyboard: $(KEYBOARD))
150 # $(info Keymap: $(KEYMAP))
151 # $(info Subproject: $(SUBPROJECT))
152 # $(info Keyboards: $(KEYBOARDS))
155 # Set the default goal depending on where we are running make from
156 # this handles the case where you run make without any arguments
157 .DEFAULT_GOAL := all:all
159 .DEFAULT_GOAL := $(KEYBOARD):$(KEYMAP)
160 else ifneq ($(KEYBOARD),)
161 # Inside a keyboard folder, build all keymaps for all subprojects
162 # Note that this is different from the old behaviour, which would
163 # build only the default keymap of the default keyboard
164 .DEFAULT_GOAL := $(KEYBOARD):all
168 # Compare the start of the RULE variable with the first argument($1)
169 # If the rules equals $1 or starts with $1:, RULE_FOUND is set to true
170 # and $1 is removed from the RULE variable
171 # Otherwise the RULE_FOUND variable is set to false, and RULE left as it was
172 # The function is a bit tricky, since there's no built in $(startswith) function
173 define COMPARE_AND_REMOVE_FROM_RULE_HELPER
178 STARTCOLON_REMOVED=$$(subst START$1:,,START$$(RULE))
179 ifneq ($$(STARTCOLON_REMOVED),START$$(RULE))
181 RULE := $$(STARTCOLON_REMOVED)
188 # This makes it easier to call COMPARE_AND_REMOVE_FROM_RULE, since it makes it behave like
189 # a function that returns the value
190 COMPARE_AND_REMOVE_FROM_RULE = $(eval $(call COMPARE_AND_REMOVE_FROM_RULE_HELPER,$1))$(RULE_FOUND)
193 # Recursively try to find a match for the start of the rule to be checked
194 # $1 The list to be checked
195 # If a match is found, then RULE_FOUND is set to true
196 # and MATCHED_ITEM to the item that was matched
197 define TRY_TO_MATCH_RULE_FROM_LIST_HELPER3
199 ifeq ($$(call COMPARE_AND_REMOVE_FROM_RULE,$$(firstword $1)),true)
200 MATCHED_ITEM := $$(firstword $1)
202 $$(eval $$(call TRY_TO_MATCH_RULE_FROM_LIST_HELPER3,$$(wordlist 2,9999,$1)))
207 # A recursive helper function for finding the longest match
208 # $1 The list to be checked
209 # It works by always removing the currently matched item from the list
210 # and call itself recursively, until a match is found
211 define TRY_TO_MATCH_RULE_FROM_LIST_HELPER2
212 # Stop the recursion when the list is empty
214 RULE_BEFORE := $$(RULE)
215 $$(eval $$(call TRY_TO_MATCH_RULE_FROM_LIST_HELPER3,$1))
216 # If a match is found in the current list, otherwise just return what we had before
217 ifeq ($$(RULE_FOUND),true)
218 # Save the best match so far and call itself recursively
219 BEST_MATCH := $$(MATCHED_ITEM)
220 BEST_MATCH_RULE := $$(RULE)
222 RULE := $$(RULE_BEFORE)
223 $$(eval $$(call TRY_TO_MATCH_RULE_FROM_LIST_HELPER2,$$(filter-out $$(MATCHED_ITEM),$1)))
229 # Recursively try to find the longest match for the start of the rule to be checked
230 # $1 The list to be checked
231 # If a match is found, then RULE_FOUND is set to true
232 # and MATCHED_ITEM to the item that was matched
233 define TRY_TO_MATCH_RULE_FROM_LIST_HELPER
235 $$(eval $$(call TRY_TO_MATCH_RULE_FROM_LIST_HELPER2,$1))
236 ifneq ($$(BEST_MATCH),)
238 RULE := $$(BEST_MATCH_RULE)
239 MATCHED_ITEM := $$(BEST_MATCH)
246 # Make it easier to call TRY_TO_MATCH_RULE_FROM_LIST
247 TRY_TO_MATCH_RULE_FROM_LIST = $(eval $(call TRY_TO_MATCH_RULE_FROM_LIST_HELPER,$1))$(RULE_FOUND)
249 define ALL_IN_LIST_LOOP
250 OLD_RULE$1 := $$(RULE)
251 $$(eval $$(call $1,$$(ITEM$1)))
252 RULE := $$(OLD_RULE$1)
255 define PARSE_ALL_IN_LIST
256 $$(foreach ITEM$1,$2,$$(eval $$(call ALL_IN_LIST_LOOP,$1)))
259 # The entry point for rule parsing
260 # parses a rule in the format <keyboard>:<keymap>:<target>
261 # but this particular function only deals with the first <keyboard> part
265 # If the rule starts with all, then continue the parsing from
266 # PARSE_ALL_KEYBOARDS
267 ifeq ($$(call COMPARE_AND_REMOVE_FROM_RULE,all),true)
268 $$(eval $$(call PARSE_ALL_KEYBOARDS))
269 else ifeq ($$(call COMPARE_AND_REMOVE_FROM_RULE,test),true)
270 $$(eval $$(call PARSE_TEST))
271 # If the rule starts with the name of a known keyboard, then continue
272 # the parsing from PARSE_KEYBOARD
273 else ifeq ($$(call TRY_TO_MATCH_RULE_FROM_LIST,$$(KEYBOARDS)),true)
274 $$(eval $$(call PARSE_KEYBOARD,$$(MATCHED_ITEM)))
275 # Otherwise use the KEYBOARD variable, which is determined either by
276 # the current directory you run make from, or passed in as an argument
277 else ifneq ($$(KEYBOARD),)
278 $$(eval $$(call PARSE_KEYBOARD,$$(KEYBOARD)))
280 $$(info make: *** No rule to make target '$1'. Stop.)
282 $$(info | QMK's make format recently changed to use folder locations and colons:)
283 $$(info | make project_folder:keymap[:target])
285 $$(info | make planck/rev4:default:dfu)
286 $$(info | make planck:default)
292 # Parses a rule in the format <keymap>:<target>
293 # the keyboard is already known when entering this function
294 define PARSE_KEYBOARD
295 # If we want to compile the default subproject, then we need to
296 # include the correct makefile to determine the actual name of it
299 # KEYBOARD_FOLDERS := $$(subst /, , $(CURRENT_KB))
301 DEFAULT_FOLDER := $$(CURRENT_KB)
303 # We assume that every rules.mk will contain the full default value
304 $$(eval include $(ROOT_DIR)/keyboards/$$(CURRENT_KB)/rules.mk)
305 ifneq ($$(DEFAULT_FOLDER),$$(CURRENT_KB))
306 $$(eval include $(ROOT_DIR)/keyboards/$$(DEFAULT_FOLDER)/rules.mk)
308 CURRENT_KB := $$(DEFAULT_FOLDER)
311 KEYBOARD_FOLDER_PATH_1 := $$(CURRENT_KB)
312 KEYBOARD_FOLDER_PATH_2 := $$(patsubst %/,%,$$(dir $$(KEYBOARD_FOLDER_PATH_1)))
313 KEYBOARD_FOLDER_PATH_3 := $$(patsubst %/,%,$$(dir $$(KEYBOARD_FOLDER_PATH_2)))
314 KEYBOARD_FOLDER_PATH_4 := $$(patsubst %/,%,$$(dir $$(KEYBOARD_FOLDER_PATH_3)))
315 KEYBOARD_FOLDER_PATH_5 := $$(patsubst %/,%,$$(dir $$(KEYBOARD_FOLDER_PATH_4)))
318 # get a list of all keymaps
319 KEYMAPS += $$(notdir $$(patsubst %/.,%,$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_1)/keymaps/*/.)))
320 KEYMAPS += $$(notdir $$(patsubst %/.,%,$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_2)/keymaps/*/.)))
321 KEYMAPS += $$(notdir $$(patsubst %/.,%,$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_3)/keymaps/*/.)))
322 KEYMAPS += $$(notdir $$(patsubst %/.,%,$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_4)/keymaps/*/.)))
323 KEYMAPS += $$(notdir $$(patsubst %/.,%,$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_5)/keymaps/*/.)))
324 # this might be needed, but in a different form
325 #KEYMAPS := $$(sort $$(filter-out $$(KEYBOARD_FOLDER_1) $$(KEYBOARD_FOLDER_2) \
326 $$(KEYBOARD_FOLDER_3) $$(KEYBOARD_FOLDER_4) $$(KEYBOARD_FOLDER_5), $$(KEYMAPS)))
329 ifneq ("$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_5)/rules.mk)","")
331 $$(eval include $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_5)/rules.mk)
332 KEYBOARD_LAYOUTS := $$(sort $$(LAYOUTS) $$(KEYBOARD_LAYOUTS))
334 ifneq ("$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_4)/rules.mk)","")
336 $$(eval include $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_4)/rules.mk)
337 KEYBOARD_LAYOUTS := $$(sort $$(LAYOUTS) $$(KEYBOARD_LAYOUTS))
339 ifneq ("$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_3)/rules.mk)","")
341 $$(eval include $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_3)/rules.mk)
342 KEYBOARD_LAYOUTS := $$(sort $$(LAYOUTS) $$(KEYBOARD_LAYOUTS))
344 ifneq ("$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_2)/rules.mk)","")
346 $$(eval include $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_2)/rules.mk)
347 KEYBOARD_LAYOUTS := $$(sort $$(LAYOUTS) $$(KEYBOARD_LAYOUTS))
349 ifneq ("$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_1)/rules.mk)","")
351 $$(eval include $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_1)/rules.mk)
352 KEYBOARD_LAYOUTS := $$(sort $$(LAYOUTS) $$(KEYBOARD_LAYOUTS))
356 $$(foreach LAYOUT,$$(KEYBOARD_LAYOUTS),$$(eval LAYOUT_KEYMAPS += $$(notdir $$(patsubst %/.,%,$$(wildcard $(ROOT_DIR)/layouts/*/$$(LAYOUT)/*/.)))))
358 KEYMAPS := $$(sort $$(KEYMAPS) $$(LAYOUT_KEYMAPS))
360 # if the rule after removing the start of it is empty (we haven't specified a kemap or target)
361 # compile all the keymaps
363 $$(eval $$(call PARSE_ALL_KEYMAPS))
364 # The same if all was specified
365 else ifeq ($$(call COMPARE_AND_REMOVE_FROM_RULE,all),true)
366 $$(eval $$(call PARSE_ALL_KEYMAPS))
367 # Try to match the specified keyamp with the list of known keymaps
368 else ifeq ($$(call TRY_TO_MATCH_RULE_FROM_LIST,$$(KEYMAPS)),true)
369 $$(eval $$(call PARSE_KEYMAP,$$(MATCHED_ITEM)))
370 # Otherwise try to match the keymap from the current folder, or arguments to the make command
371 else ifneq ($$(KEYMAP),)
372 $$(eval $$(call PARSE_KEYMAP,$$(KEYMAP)))
373 # Otherwise, make all keymaps, again this is consistent with how it works without
376 $$(eval $$(call PARSE_ALL_KEYMAPS))
380 # if we are going to compile all keyboards, match the rest of the rule
382 define PARSE_ALL_KEYBOARDS
383 $$(eval $$(call PARSE_ALL_IN_LIST,PARSE_KEYBOARD,$(KEYBOARDS)))
387 # When entering this, the keyboard and subproject are known, so now we need
388 # to determine which keymaps are going to get compiled
389 # define PARSE_SUBPROJECT
393 # If we want to parse all subprojects, but the keyboard doesn't have any,
394 # then use defaultsp instead
395 # define PARSE_ALL_SUBPROJECTS
396 # ifeq ($$(SUBPROJECTS),)
397 # $$(eval $$(call PARSE_SUBPROJECT,defaultsp))
399 # $$(eval $$(call PARSE_ALL_IN_LIST,PARSE_SUBPROJECT,$$(SUBPROJECTS)))
404 # This is the meat of compiling a keyboard, when entering this, everything is known
405 # keyboard, subproject, and keymap
406 # Note that we are not directly calling the command here, but instead building a list,
407 # which will later be processed
410 # The rest of the rule is the target
411 # Remove the leading ":" from the target, as it acts as a separator
412 MAKE_TARGET := $$(patsubst :%,%,$$(RULE))
413 # We need to generate an unique indentifer to append to the COMMANDS list
414 CURRENT_KB_UNDER := $$(subst /,_,$$(CURRENT_KB))
415 COMMAND := COMMAND_KEYBOARD_$$(CURRENT_KB_UNDER)_KEYMAP_$$(CURRENT_KM)
416 # If we are compiling a keyboard without a subproject, we want to display just the name
417 # of the keyboard, otherwise keyboard/subproject
418 KB_SP := $$(CURRENT_KB)
420 KB_SP := $(BOLD)$$(KB_SP)$(NO_COLOR)
421 # Specify the variables that we are passing forward to submake
422 MAKE_VARS := KEYBOARD=$$(CURRENT_KB) KEYMAP=$$(CURRENT_KM)
423 # And the first part of the make command
424 MAKE_CMD := $$(MAKE) -r -R -C $(ROOT_DIR) -f build_keyboard.mk $$(MAKE_TARGET)
425 # The message to display
426 MAKE_MSG := $$(MSG_MAKE_KB)
427 # We run the command differently, depending on if we want more output or not
428 # The true version for silent output and the false version otherwise
429 $$(eval $$(call BUILD))
433 MAKE_VARS += VERBOSE=$(VERBOSE) COLOR=$(COLOR)
434 COMMANDS += $$(COMMAND)
435 COMMAND_true_$$(COMMAND) := \
436 printf "$$(MAKE_MSG)" | \
437 $$(MAKE_MSG_FORMAT); \
438 LOG=$$$$($$(MAKE_CMD) $$(MAKE_VARS) SILENT=true 2>&1) ; \
439 if [ $$$$? -gt 0 ]; \
440 then $$(PRINT_ERROR_PLAIN); \
441 elif [ "$$$$LOG" != "" ] ; \
442 then $$(PRINT_WARNING_PLAIN); \
446 COMMAND_false_$$(COMMAND) := \
447 printf "$$(MAKE_MSG)\n\n"; \
448 $$(MAKE_CMD) $$(MAKE_VARS) SILENT=false; \
449 if [ $$$$? -gt 0 ]; \
450 then error_occurred=1; \
454 # Just parse all the keymaps for a specific keyboard
455 define PARSE_ALL_KEYMAPS
456 $$(eval $$(call PARSE_ALL_IN_LIST,PARSE_KEYMAP,$$(KEYMAPS)))
463 MAKE_CMD := $$(MAKE) -r -R -C $(ROOT_DIR) -f build_test.mk $$(MAKE_TARGET)
464 MAKE_VARS := TEST=$$(TEST_NAME) FULL_TESTS="$$(FULL_TESTS)"
465 MAKE_MSG := $$(MSG_MAKE_TEST)
466 $$(eval $$(call BUILD))
467 ifneq ($$(MAKE_TARGET),clean)
468 TEST_EXECUTABLE := $$(TEST_DIR)/$$(TEST_NAME).elf
469 TESTS += $$(TEST_NAME)
470 TEST_MSG := $$(MSG_TEST)
471 $$(TEST_NAME)_COMMAND := \
472 printf "$$(TEST_MSG)\n"; \
473 $$(TEST_EXECUTABLE); \
474 if [ $$$$? -gt 0 ]; \
475 then error_occurred=1; \
483 TEST_NAME := $$(firstword $$(subst :, ,$$(RULE)))
484 TEST_TARGET := $$(subst $$(TEST_NAME),,$$(subst $$(TEST_NAME):,,$$(RULE)))
485 ifeq ($$(TEST_NAME),all)
486 MATCHED_TESTS := $$(TEST_LIST)
488 MATCHED_TESTS := $$(foreach TEST,$$(TEST_LIST),$$(if $$(findstring $$(TEST_NAME),$$(TEST)),$$(TEST),))
490 $$(foreach TEST,$$(MATCHED_TESTS),$$(eval $$(call BUILD_TEST,$$(TEST),$$(TEST_TARGET))))
494 # Set the silent mode depending on if we are trying to compile multiple keyboards or not
495 # By default it's on in that case, but it can be overridden by specifying silent=false
496 # from the command line
497 define SET_SILENT_MODE
499 SILENT_MODE := $(SUB_IS_SILENT)
500 else ifeq ($$(words $$(COMMANDS)),1)
507 include $(ROOT_DIR)/message.mk
509 ifeq ($(strip $(BREAK_ON_ERRORS)), yes)
510 HANDLE_ERROR = exit 1
512 HANDLE_ERROR = echo $$error_occurred > $(ERROR_FILE)
515 # The empty line is important here, as it will force a new shell to be created for each command
516 # Otherwise the command line will become too long with a lot of keyboards and keymaps
519 $(COMMAND_$(SILENT_MODE)_$(COMMAND))\
520 if [ $$error_occurred -gt 0 ]; then $(HANDLE_ERROR); fi;
527 if [ $$error_occurred -gt 0 ]; then $(HANDLE_ERROR); fi;
532 # Let's match everything, we handle all the rule parsing ourselves
535 # Check if we have the CMP tool installed
536 cmp $(ROOT_DIR)/Makefile $(ROOT_DIR)/Makefile >/dev/null 2>&1; if [ $$? -gt 0 ]; then printf "$(MSG_NO_CMP)"; exit 1; fi;
537 # Ensure that python3 is installed. This check can be removed after python is used in more places.
538 if ! python3 --version 1> /dev/null 2>&1; then printf "$(MSG_PYTHON_MISSING)"; fi
539 # Check if the submodules are dirty, and display a warning if they are
541 if [ ! -e lib/chibios ]; then git submodule sync lib/chibios && git submodule update --depth 1 --init lib/chibios; fi
542 if [ ! -e lib/chibios-contrib ]; then git submodule sync lib/chibios-contrib && git submodule update --depth 1 --init lib/chibios-contrib; fi
543 if [ ! -e lib/ugfx ]; then git submodule sync lib/ugfx && git submodule update --depth 1 --init lib/ugfx; fi
544 git submodule status --recursive 2>/dev/null | \
545 while IFS= read -r x; do \
548 *) printf "$(MSG_SUBMODULE_DIRTY)";break;; \
552 rm -f $(ERROR_FILE) > /dev/null 2>&1
553 $(eval $(call PARSE_RULE,$@))
554 $(eval $(call SET_SILENT_MODE))
555 # Run all the commands in the same shell, notice the + at the first line
556 # it has to be there to allow parallel execution of the submake
557 # This always tries to compile everything, even if error occurs in the middle
558 # But we return the error code at the end, to trigger travis failures
559 # The sort at this point is to remove duplicates
560 $(foreach COMMAND,$(sort $(COMMANDS)),$(RUN_COMMAND))
561 if [ -f $(ERROR_FILE) ]; then printf "$(MSG_ERRORS)" & exit 1; fi;
562 $(foreach TEST,$(sort $(TESTS)),$(RUN_TEST))
563 if [ -f $(ERROR_FILE) ]; then printf "$(MSG_ERRORS)" & exit 1; fi;
565 # These no longer work because of the colon system
567 # All should compile everything
569 # all: all-keyboards test-all
571 # Define some shortcuts, mostly for compatibility with the old syntax
572 # .PHONY: all-keyboards
573 # all-keyboards: all\:all\:all
575 # .PHONY: all-keyboards-defaults
576 # all-keyboards-defaults: all\:default
582 # test-clean: test-all-clean
585 git submodule sync $?
586 git submodule update --init $?
588 .PHONY: git-submodule
590 git submodule sync --recursive
591 git submodule update --init --recursive --progress
597 # Generate the version.h file
599 GIT_VERSION := $(shell git describe --abbrev=6 --dirty --always --tags 2>/dev/null || date +"%Y-%m-%d-%H:%M:%S")
604 BUILD_DATE := $(shell date +"%Y-%m-%d-%H:%M:%S")
605 $(shell echo '#define QMK_VERSION "$(GIT_VERSION)"' > $(ROOT_DIR)/quantum/version.h)
606 $(shell echo '#define QMK_BUILDDATE "$(BUILD_DATE)"' >> $(ROOT_DIR)/quantum/version.h)
611 include $(ROOT_DIR)/testlist.mk